package form.edit;

import form.*;
import form.comp.*;
import form.data.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;


public class FormMenu extends MenuBar implements ActionListener, ItemListener {

	private Menu edit = null;
	private Menu insert = null;
	private Viewer viewer = null;
	private Data data = null;

	public FormMenu(Viewer viewer,Data data){
		super();

		this.viewer = viewer;
		this.data = data;

		//File Menu
		Menu file = new Menu("File");

		MenuItem newf = new MenuItem("New");
		newf.setActionCommand("newf");
		file.add(newf);

		MenuItem openLocal = new MenuItem("Open Local");
		openLocal.setActionCommand("openLocal");
		file.add(openLocal);

		MenuItem openFtp = new MenuItem("Open Ftp");
		openFtp.setActionCommand("openFtp");
		file.add(openFtp);

		MenuItem saveLocal = new MenuItem("Save Local");
		saveLocal.setActionCommand("saveLocal");
		file.add(saveLocal);

		MenuItem saveFtp = new MenuItem("Save Ftp");
		saveFtp.setActionCommand("saveFtp");
		file.add(saveFtp);

		MenuItem exit = new MenuItem("Exit");
		exit.setActionCommand("exit");
		file.add(exit);

		add(file);
		file.addActionListener(this);

		MenuItem refresh = new MenuItem("Refresh");
		refresh.setActionCommand("refresh");

		MenuItem remove = new MenuItem("Remove");
		remove.setActionCommand("remove");

		MenuItem properties = new MenuItem("Properties");
		properties.setActionCommand("properties");

		MenuItem passwords = new MenuItem("Passwords");
		passwords.setActionCommand("passwords");

		MenuItem outputeditor = new MenuItem("Output Editor");
		outputeditor.setActionCommand("outputeditor");

		edit = new Menu("Edit");
		edit.add(refresh);
		edit.add(remove);
		edit.add(properties);
		edit.add(passwords);
		edit.add(outputeditor);

		add(edit);
		edit.addActionListener(this);

		insert = new Menu("Insert");

		MenuItem textField = new MenuItem("Text Field");
		textField.setActionCommand("FormTextField");
		insert.add(textField);

		MenuItem label = new MenuItem("Label");
		label.setActionCommand("Label");
		insert.add(label);

		MenuItem button = new MenuItem("Button");
		button.setActionCommand("FormButton");
		insert.add(button);

		MenuItem grid = new MenuItem("Grid");
		grid.setActionCommand("Grid");
		insert.add(grid);

		add(insert);
		insert.addActionListener(this);

		
	}

    public void actionPerformed(ActionEvent e) {

		if (e.getActionCommand().equals("newf") ){
			viewer.newForm();
		}

		if (e.getActionCommand().equals("openLocal") ){
			viewer.openLocal();
		}

		if (e.getActionCommand().equals("openFtp") ){
			viewer.openFtp();
		}

		if (e.getActionCommand().equals("saveLocal") ){
			viewer.saveLocal();
		}

		if (e.getActionCommand().equals("saveFtp") ){
			viewer.saveFtp();
		}

		if (e.getActionCommand().equals("exit") ){
			System.exit(1);
		}

		else if ( ((MenuItem)(e.getSource())).getLabel().equals("Insert") ){
			AskDialog ad = new AskDialog("Insert","Enter Unique name.");
			String name = ad.answer();

			while ( viewer.contains(name) ){
			   ErrorDialog ed = new ErrorDialog(new Frame(), "Name must be unique");
			   ad.show();
			   name = ad.answer();
			}
				
			if (name != null) {

		         if (e.getActionCommand().equals("FormTextField") ){
			   viewer.add(new FormTextField(name));
		         }
		         if (e.getActionCommand().equals("Label") ){
			   viewer.add(new FormLabel(name));
		         }
		         else if (e.getActionCommand().equals("FormButton") ){
			   viewer.add(new FormButton(name));
		         }
		         else if (e.getActionCommand().equals("Grid") ){
			    ad = new AskDialog("Insert","Enter rows.");
			    int rows = Integer.valueOf(ad.answer()).intValue();
			    ad = new AskDialog("Insert","Enter columns.");
			    int cols = Integer.valueOf(ad.answer()).intValue();

			    FormInterface newComp = null;
			    int val =0;
			    for (int i =0;i < rows; i++){
				for (int j =0;j < cols; j++){
				  val = (i*rows) +j+1;
				  newComp = new FormLabel(name+val);
				  viewer.add(newComp);
			        }
				newComp.setEndOfRow(true);
				for (int j =0;j < cols; j++){
				  val = (i +1)*(j+1);
				  newComp = new FormTextField("TF"+name+val);
				  viewer.add(newComp);
			        }
				newComp.setEndOfRow(true);
			    }
			    viewer.refresh();
		         }
		   }
		}

		else if (e.getActionCommand().equals("properties") ){
			data.showProperties();
		}

		else if (e.getActionCommand().equals("passwords") ){
			data.showPasswords();
		}

		else if (e.getActionCommand().equals("outputeditor") ){
			data.showOutputEditor();
		}

		else if (e.getActionCommand().equals("refresh") ){
			viewer.refresh();
		}
		else if (e.getActionCommand().equals("remove") ){
			viewer.removeSelected();
		}
    }

    public void itemStateChanged(ItemEvent e) {
        System.out.println("Item state change detected on item \""
                      + e.getItem()
                      + "\" (state is " 
                      + ((e.getStateChange() == 
                            ItemEvent.SELECTED)? 
                            "selected)."
                          : "deselected).")
                      );
    }

}
