/**
* The class responsible for saveing the data and submitting the job
* @author Randy Levensalor
* @version 3.0
*/

package form.io;

import form.run.*;
import java.io.*;
import java.awt.*;
import java.util.*;
import java.net.*;
import form.data.*;

public class Save implements Serializable{

	/**
	* The writer for the output stream to the file
	*/
	private PrintWriter outWriter = null;

	private String resultUrl = "";
	private String sid = "";
	private String destination = "";
	private String host = "";

    /**
    * The type of file being opened
    * Must be initialized in constructor and
    * not changes after words
    */
    private int type;

    public final static int LOCAL  = 0;
    public final static int FTP    = 1;
    public final static int SUBMIT = 2;

	public final static String ID = "id=";
	public final static String IDTERM = "\n";

	private boolean fail = false;

	/**
	* Checks if the save failed
	*/
	public boolean failed(){ return fail;}
	
	/**
	* Saves a file locally or via ftp or submits job to CGI
	* @param int type = type of save (LOCAL FTP SUBMIT)
	* @param Frame frame Used for save dialogs
	*/
	public Save(int type, Frame frame){
	   if (type == LOCAL){
	      this.type = type;
	      saveLocal(frame);
	   }
	   else if (type == FTP){
	      this.type = type;
	      saveFtp(frame);
	   }
	   else if (type == SUBMIT){
	       this.type = type;
	   }
	   else {
	       System.out.println("invalid save type.  Save failed");
	       fail = true;
	   }
	}
	
	private boolean saveLocal(Frame frame){

		FileDialog fd = new FileDialog(frame,"Save",FileDialog.SAVE);
		fd.show();

		if (fd.getDirectory()!=null){
		  String fileName = fd.getDirectory()+fd.getFile();

	          try {
		     FileWriter fw = new FileWriter(fileName);
		     outWriter = new PrintWriter(fw,true);
	          } catch (IOException e) { 
			System.out.println("Cannot open local file "+fileName); 
			fail = true;
		  }
		}
		else {
	 	  fail = true;
	        }
		return fail;
	}

	private boolean saveFtp(Frame frame){

		FtpDialog ftp = new FtpDialog(frame,FtpDialog.SAVE);

		outWriter = ftp.getWriter();

		if (outWriter == null){
		  fail = true;
		 }
		 return fail;
	}

	public void save(String data){
		if (type != SUBMIT){
		   outWriter.print(data);
		   outWriter.close();
		}
	}

	private String httpResults(URL url){
		String line = "";
		String results = "";

		try {

			BufferedReader in = new BufferedReader(new InputStreamReader( url.openStream() ) );
	    	while ( (line = in.readLine()) != null){;
				if (line.startsWith("url=")){
					resultUrl =host+line.substring(4);
					System.out.println("resluturl "+resultUrl);
				}
				results += line+"\n";
			}
			System.out.println(results);

		}catch (java.io.IOException e){e.printStackTrace();}

		return results;
	}
	
		
	private void setSID(String data){
		int loc = data.indexOf(ID);
		if (loc > 0)
			sid = data.substring(loc+ID.length(),data.indexOf(IDTERM,loc));
		else System.out.println("fuck");
		System.out.println("sid "+sid);
	}


String email = "";
	/**
	* submits the file to run from applet
	* @param String destination the destination url (must begin with http://
	*/
	public void submit(String name, String emai, String hos,String dest){
		email = emai;
		host = hos;
		destination = hos+dest;
		System.out.println("DEST "+destination);
		String results = "";
		try{
			URL url = new URL(destination+"?name="+name+"&email="+email);

			results = httpResults(url);
			setSID(results);
		}catch(Exception e){e.printStackTrace();}
	}

	public void sendClose(String passwords){

		URL url;

		String prefix = "?";
		//String prefix = "?close"+ID+sid;
				System.out.println("CLOSE: "+destination+prefix+"close"+ID+sid+"&"+email+passwords);
	    int i = 0;
		try{
				url = new URL(destination+prefix+URLEncoder.encode("close"+ID+sid+"&passwords=&"+email+passwords));
				httpResults(url);
		}catch (java.net.MalformedURLException e){e.printStackTrace();}
	}
			
	public String sendGet(String pre, String data){

		URL url;

		//String prefix = "?"+ID+sid+"&"+pre;
		String prefix = ID+sid+"&"+pre;
		//System.out.println("SENDING "+data);
		System.out.println("PRE "+destination+prefix);
	    int i = 0;
		try{
			while(data.length() > 1000){
				url = new URL(destination+"?"+URLEncoder.encode(prefix+(i++)+"="+data.substring(0,1000)));
				httpResults(url);
				data=data.substring(1000);
			}

			url = new URL(destination+"?"+URLEncoder.encode(prefix+(i++)+"="+data));
				httpResults(url);
		}catch (java.net.MalformedURLException e){e.printStackTrace();}

		return resultUrl;
	}
			

}
